<?php
/*
Plugin Name: Prediction League
Plugin URI: http://www.liga.parkdrei.de
Description: Prediction League / Sporty Office / Fu&szlig;balltip
Author: Robert Kapp
Version: 1.0.4
CHANGES: 

License: GPL
Author URI: http://www.liga.parkdrei.de/predictionleague

Min WP Version: ??
Max WP Version: 2.9.2

*/
define('PL_VERSION', "1.0.4");
include(ABSPATH."/wp-content/plugins/predictionleague/lib.php");

/* export */
	if ($_REQUEST['action'] == "export"){
		$competition_id = $_REQUEST['competition_id'];settype($competition_id, INT);
		pl_export_competition($competition_id);
		exit;
		}		


/* create db while the activation process */
add_action('activate_predictionleague/admin.php', 'prediction_league_install');

/* get the options */
if ($pl_optionstring = get_option('predictionleague_options')){
	$pl_options = pl_read_option_string($pl_optionstring);} 
else {
	$pl_options = pl_set_default_options_array();
	$option_string = pl_create_option_string($pl_options);
	update_option("predictionleague_options", mysql_real_escape_string($option_string));
	}
/* get the language file */
if (file_exists(ABSPATH."/wp-content/plugins/predictionleague/language/".$pl_options['language'].".php")){
	include(ABSPATH."/wp-content/plugins/predictionleague/language/".$pl_options['language'].".php");
	}

	/* display the view.php */
	function pl_print_predictionleague($content) {
		global $pl_options;
		$page_id = $pl_options['page_id'];
			if(is_page($page_id) AND $page_id!="")
			{
			echo $content;
			include_once ("view.php");
			}
			else	
			{return $content;}
		}
	/* if everything is ok */	
	if (pl_check_tables()){
		/* check the next round */
		pl_check_next_day();
		/* print the content */
		add_action('the_content', 'pl_print_predictionleague');
	}

	/* menu (Tipspiel, Manage) */
	add_action('admin_menu', 'add_predictionleague');

	function add_predictionleague() {
		add_menu_page(__('Options', 'Prediction League'), __('Prediction League', 'predictionleague'),
		'edit_others_posts', 	'predictionleague', 'pl_options_page');

		add_submenu_page( 'predictionleague' , __('competitions', 'predictionleague'), __('Competitions', 'predictionleague'), 'edit_others_posts',
		'competitions', 'pl_competition_page');

		add_submenu_page( 'predictionleague' , __('infos', 'predictionleague'), __('Help/Infos', 'predictionleague'), 'edit_others_posts',
		'infos', 'pl_info_page');
		}

	/* version */
	add_action('wp_head', 'add_predictionleague_version');
	function add_predictionleague_version() {
		echo "<meta name='Prediction League' content='".PREDICTIONLEAGUEVERSION."' />\n";
	}


	
/* adminpage main function */
function pl_options_page() {
global $wpdb, $pl_options;
/** Actions  */
if ($_REQUEST['action'] == "deletetables" AND !$_REQUEST['confirm']){
	$link = '?page=predictionleague&amp;action=deletetables';
	pl_admin_message(DeleteTables, 200, 800, 1, $link);
	}
if ($_REQUEST['action'] == "deletetables" and $_REQUEST['confirm'] == "yes"){
	if (pl_delete_tables()){pl_admin_message(TablesDeleted, 200, 800);}
	}
if ($_REQUEST['action'] == "createtables"){
	if (pl_create_tables()){pl_admin_message(TablesCreated, 200, 800);}
	}
if ($_REQUEST['action'] == "editoptions"){
	/* collect the vars */
	$pl_options['page_id'] 		= $_POST['page_id'];settype($pl_options['page_id'], INT);
	$pl_options['tablewidth'] 		= $_POST['tablewidth'];settype($pl_options['tablewidth'], INT);
	$pl_options['language'] 		= $_POST['language'];strip_tags($pl_options['language']);
	$pl_options['tablecolor1']		= $_POST['tablecolor1'];strip_tags($pl_options['tablecolor1']);
	$pl_options['tablecolor2']		= $_POST['tablecolor2'];strip_tags($pl_options['tablecolor2']);
	$pl_options['bordercolor']		= $_POST['bordercolor'];strip_tags($pl_options['bordercolor']);
	$pl_options['navigationcolor1']= $_POST['navigationcolor1'];strip_tags($pl_options['navigationcolor1']);
	$pl_options['navigationcolor2']= $_POST['navigationcolor2'];strip_tags($pl_options['navigationcolor2']);
	$pl_options['fontcolor']		= $_POST['fontcolor'];strip_tags($pl_options['fontcolor']);
	$pl_options['linkcolor']		= $_POST['linkcolor'];strip_tags($pl_options['linkcolor']);
	$pl_option_string = pl_create_option_string($pl_options);
	update_option("predictionleague_options", mysql_real_escape_string($pl_option_string));
	$pl_optionstring = get_option('predictionleague_options');
	$pl_options = pl_read_option_string($pl_optionstring);
	}
?>
	<!-- color picker -->
	<script language="javascript">
	var which_input;
	// The function name fillColorValue must be used
	// to get the color value. This function takes a string
	// as the color value in a hexidacimal format (e.g. FFFFFF)
	// the function code can be anything the application need.
	function fillColorValue(color){
		document.getElementById(which_input).value = color;
		document.getElementById(which_input+"_div").style.backgroundColor = "#"+color;
	}

	function show_picker(ID, Current_Color, Previous_Color){
		which_input = ID;
		var lnk = "../wp-content/plugins/predictionleague/color_picker/color_picker_files/color_picker_interface.html\
		?cur_color="+Current_Color+"&pre_color="+Previous_Color;
		window.open(lnk, "", "width=465, height=350");
	}
	</script>
	<!-- header -->
	<div class="wrap">
<?php
echo '<h3>'.MainOptions.'</h3>';

if(pl_check_tables()){
	echo '<p>'.TablesOk.'</p>';
	}
else {
	echo '<p>'.TablesNotOk.'</p>';
	echo '<p><a href="?page=predictionleague&amp;action=createtables">'.CreateTablesLink.'</a></p>';
	}
pl_print_main_option_form($pl_options);

echo '<p><a href="?page=predictionleague&amp;action=deletetables">'.DeleteTablesLink.'</a></p>';
}


/* 
 * 
 * manage competitions 
 * 
 * */
function pl_competition_page() {
/*
 * if there is something wrong with the tables
 */	
if (!pl_check_tables()){
	echo '<div class="wrap">';
	echo '<h3>'.NoCompleteSetup.'</h3>';
	echo '</div>';
	return FALSE;
	}
$competition_id = $_REQUEST['competition_id'];settype($competition_id, INT);
$do = $_REQUEST['do'];strip_tags($do);
$action = $_REQUEST['action'];strip_tags($action);
$form = '';
/* import */
if ($action == "importcompetition"){
	global $filename;
	$filename = $_FILES['importxml']['tmp_name'];
	if ($filename){
		include("import_competition.php");}
		$action = "edit";
	}	
/* save the option changes */
if($do == "change"){
	$form->id			= $competition_id;
	$form->name			= $_POST['name'];
	$form->rounds		= $_POST['rounds'];
	$form->round_names	= $_POST['round_names'];
	$form->points_one	= $_POST['points_one'];
	$form->points_two	= $_POST['points_two'];
	$form->points_three	= $_POST['points_three'];
	$form->points_four	= $_POST['points_four'];
	$form->tiptime		= $_POST['tiptime'];
	$form->active		= $_POST['active'];
	/* checks */
	if ($form->id){settype($form->id, INT);}	
	settype($form->rounds, INT);	
	settype($form->points_one, INT);	
	settype($form->points_two, INT);	
	settype($form->points_three, INT);	
	settype($form->points_four, INT);	
	settype($form->tiptime, INT);
	settype($form->active, INT);
	strip_tags($form->name);
	strip_tags($form->round_names);	
	pl_save_competition($form);	
	unset($do);				
	}
/* save the team changes */
if($do == "changeteam"){
	$form->id				= $_REQUEST['team_id'];
	$form->team_name		= $_POST['team_name'];
	$form->team_shortname	= $_POST['team_shortname'];
	$form->competition_id	= $competition_id;
	settype($form->id, INT);	
	settype($form->competition_id, INT);
	strip_tags($form->team_name);
	strip_tags($form->team_shortname);	
	pl_save_team($form);
	$do = "manageteams";
	}
/* delete a team */
if($do == "deleteteam"){
	$form->id				= $_REQUEST['team_id'];
	settype($form->id, INT);	
	pl_delete_team($form);
	$do = "manageteams";
	}
/* save the game changes */
if($do == "changegame"){
	$numberofgames 	= $_POST['numberofgames'];
	if ($numberofgames){
		for ($x=1; $x<=$numberofgames; $x++){	
			$form->id				= $_POST['game_id-'.$x];
			$form->team1			= $_POST['team1-'.$x];
			$form->team2			= $_POST['team2-'.$x];
			$day					= $_POST['day-'.$x];
			$month					= $_POST['month-'.$x];
			$year					= $_POST['year-'.$x];
			$hour					= $_POST['hour-'.$x];
			$minute					= $_POST['minute-'.$x];
			settype($day, INT);settype($month, INT);settype($year, INT);settype($hour, INT);settype($minute, INT);	
			$form->gametime 		= mktime($hour, $minute, 0, $month, $day, $year);
			$form->competition_id	= $competition_id;
			$form->round			= $_REQUEST['round'];
			settype($form->id, INT);	
			settype($form->competition_id, INT);
			settype($form->team1, INT);
			settype($form->team2, INT);
			settype($form->gametime, INT);
			settype($form->round, INT);	
			pl_save_game($form);
	}}
	$do = "managegames";
	}
/* delete a game */
if($do == "deletegame"){
	$form->id				= $_REQUEST['game_id'];
	settype($form->id, INT);	
	pl_delete_game($form);
	$do = "managegames";
	}
/* delete a competition */
if($do == "deletecompetition" AND !$_REQUEST['confirm']){
	$link = '?page=competitions&amp;action=edit&amp;do=deletecompetition&amp;competition_id='.$competition_id;
	pl_admin_message(DeleteCompetition, 200, 800, 1, $link);
	unset($competition_id);
	}

if($do == "deletecompetition" AND $_REQUEST['confirm'] == "yes"){
	pl_delete_competition($competition_id);
	pl_admin_message(CompetitionDeleted, 200, 800);
	unset($competition_id);
	}
/* save results and calculate the points */
if($do == "sendresults"){
	$numberofgames 	= $_POST['numberofgames'];
	if ($numberofgames){
		for ($x=1; $x<=$numberofgames; $x++){	
			$form->id				= $_POST['game_id-'.$x];
			$form->team1_score		= $_POST['team1_score-'.$x];
			$form->team2_score		= $_POST['team2_score-'.$x];
			$form->competition_id	= $competition_id;
			$form->round			= $_REQUEST['round'];
			settype($form->id, INT);	
			settype($form->competition_id, INT);
			/* to avoid the 0 and nothing problem */
			if ($form->team1_score == ""){$form->team1_score = "NULL";}
			if ($form->team2_score == ""){$form->team2_score = "NULL";}
			if ($form->team1_score != "NULL"){settype($form->team1_score, INT);}
			if ($form->team2_score != "NULL"){settype($form->team2_score, INT);}
			settype($form->round, INT);	
			pl_save_results($form);
		}}
	pl_calculate_points($competition_id, $form->round);
	/* save draft */
	if ($_POST['savedraft'] == 1)
		{
		$competition = pl_get_competition($competition_id);
		$_POST['post_category'] = $_POST['category'];settype($_POST['post_category'], INT);
		$_POST['post_title'] 	= Analysis.' '.$competition->name.' - '.pl_get_round_name($form->round, $competition->round_names);
		$_POST['post_content'] = pl_get_results_for_draft($competition_id, $form->round);		
		$_POST['post_content'] .= pl_get_results_for_draft($competition_id, 0);		
		wp_insert_post($_POST);
		}
	}

/* manage user tips */
if ($do == "editusertips"){
	
	$round = $_REQUEST['round']; settype($round, INT);
	$userID = $_REQUEST['userID']; settype($userID, INT);

	$games = pl_get_games($competition_id, $round);
	// $users = pl_get_all_users();

		if ($games){
			foreach($games as $game){
				$recent_user_tips='';			
				$recent_user_tips = pl_get_recent_user_tips($game['id'], $userID);
				$new_team1tip = $_POST['team1-'.$userID.'-'.$game['id']];settype($new_team1tip, INT);
				$new_team2tip = $_POST['team2-'.$userID.'-'.$game['id']];settype($new_team2tip, INT);
				/* save only the changes */
				if ($recent_user_tips->team1tip != $new_team1tip OR $recent_user_tips->team2tip != $new_team2tip ){
					pl_update_tip($game['id'], $new_team1tip, $new_team2tip, $userID);
					}
				if (!$recent_user_tips AND $new_team1tip AND $new_team2tip){
					pl_update_tip($game['id'], $new_team1tip, $new_team2tip, $userID);
					}
				}
			}
}

/* If there is no competitionID print the Main menu */
if (!$competition_id){pl_print_main_menu_competitions();}
if ($competition_id){pl_print_sub_menu_competitions($competition_id);}
if ($do == "new"){pl_print_competition_option_form('');}
if ($competition_id){
	/* prints the options */
	if ($action == "edit" AND !$do){
		pl_print_competition_option_form($competition_id);
		}
	/* team list */
	if ($do == "manageteams"){
		pl_print_manage_teams($competition_id);
		}
	/* manage the games */
	if ($do == "managegames"){
		$round = $_REQUEST['round'];
		settype($round, INT);
		pl_print_manage_games($competition_id, $round);
		}
	/* manage the results */
	if ($action == "manageresults"){
		$round = $_REQUEST['round'];
		settype($round, INT);
		pl_print_manage_results($competition_id, $round);
		}
	/* manage the results */
	if ($action == "manageusertips"){
		$round = $_REQUEST['round'];
		settype($round, INT);
		pl_print_manage_usertips($competition_id, $round);
		}
	}
}



?>